///////////////////////////////////////////////////////////////////
//DoppelPendel Winkel-Winkelgeschwindigkeit -Diagramm für beide Pendel
//Demo-Modus: Pendel wird angezeigt
///////////////////////////////////////////////////////////////

// Attribute:
int n = 4;            // Anzahl der Variablen
float[] ZVaktuell = {3.14, 3.14, 0, 0}; // Initialisierung w1,w2,g1,g2
float w1,w2; //Winkel von der Senkrechten weg
float W1,W2; //Für Runge-Kutta verwendet: Winkel in Ruhelage: PI
float g1,g2; //Winkelgeschwindigkeiten
float wK,gK,w2K,g2K; //Koordinaten der Phasenpunkte
float f = 500;        
float masse;
float E; //Gesamtenergie mit Nullniveau in Ruhelage
float L = 180;
float G = 0;//Keine Schwerkraft
float dt = 0.15;      // Zeitschritt
//Lage der Massen
float masse1X ;
float masse1Y ;
float masse2X ;
float masse2Y ;
float l = 130;           // Pendellänge
float EKontrolleA;
float ruhelage = 300;         // Ruhelag in x-Koordinate
int M,m, AnzahlStartpunkte;
float wVor,wNach;
color farbe;
///////////////////////////////////////////////////////////////////
void setup() {
  size(600, 1200); 
  ellipseMode(CENTER);
  background(0);
  frameRate(f);
  EKontrolleA=0;
  masse =1;
  neuStarten(); 
  
}
////////////////////////////////////////////////////////////////////////
void draw(){
  fill(255);
  noStroke();
  rect(0,0,600,600);//Pendelbild löschen
  pendelDisplay();
  pendelUpdate(); 
}


////////////////////////////////////////////////////////////////////////////
void pendelUpdate(){
    // Zustand nach nächstem Zeitschritt mit Runge-Kutta 4 berechnen
    // "float[] ableitungZeit" entspricht der zeitlichen Ableitung dy/dt (4-dimensional). 
    
    //Die folgende Zeile ist Bestandteil für das Zeichnen eines Poincaré-Schnitts
   
    float[] K1 = ableitungZeit( ZVaktuell); 
    // K2 =ZustandsVektor(t0 + dt/2, ZVaktuell + dt/2 * K1)
    float[] ZVtemp = new float[n];
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K1[i]*dt*0.5;    
    }
    float[] K2 = ableitungZeit(ZVtemp);
    // K3 =ZustandsVektor(t0 + dt/2, ZVaktuell + dt/2 * K2)
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K2[i]*dt*0.5;
    }
    float[] K3 = ableitungZeit(ZVtemp);
    // K4 =ZustandsVektor(t0 + dt, ZVaktuell + dt * K3)
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K3[i]*dt;
    }
    float[] K4 = ableitungZeit(ZVtemp);
    // Zusammenfassung
    //  ZVaktuell = ZVaktuell + dt/6 * (K1 + 2*(K2+K3) + K4)
    for (int i=0; i<n; i++) {
      ZVaktuell[i] = ZVaktuell[i] + dt / 6.0 * (K1[i] + 2.0*(K2[i] + K3[i]) + K4[i]);
    }  
    //Jedes neue Winkelpaar wird gezeichnet  
     wK = map(ZVaktuell[0],2*PI-0.6,0.6,0,600);  //Koordinaten der Poincaré-Schnitt Punkte 
     gK = map(ZVaktuell[2],-0.5, 0.5,1200,800);   
     w2K = map(ZVaktuell[1],2*PI-0.6,0.6,0,600); 
     g2K = map(ZVaktuell[3],-0.5, 0.5,1200,800);  
     //Punkte Zeichnen       
     stroke(color(255,0,0));
     strokeWeight(1);
     point(wK,gK);  
     stroke(color(0,255,0));
     point(w2K,g2K);        
      
    //Winkel immer zwischen 0 und 2*PI 
    if(ZVaktuell[0] > 2*PI) ZVaktuell[0] = ZVaktuell[0] - 2*PI;
    if(ZVaktuell[0] < 0)    ZVaktuell[0] = ZVaktuell[0] + 2*PI;
    if(ZVaktuell[1] > 2*PI) ZVaktuell[1] = ZVaktuell[1] - 2*PI;
    if(ZVaktuell[1] < 0)    ZVaktuell[1] = ZVaktuell[1] + 2*PI;
    //Die folgenden zwei Zeilen dienen der Energiekontrolle
    // EKontrolleA = masse*ZVaktuell[2]*ZVaktuell[2]*L*L +0.5*masse*ZVaktuell[3]*ZVaktuell[3]*L*L + masse*ZVaktuell[2]*ZVaktuell[3]*L*L*cos(ZVaktuell[1]-ZVaktuell[0]) - G*masse*L*(2*cos(ZVaktuell[0])+cos(ZVaktuell[1])-3);
    // println("Energie "+EKontrolleA);
}
/////////////////////////////////////////////////////////////////////////////////
void pendelDisplay(){
    colorMode(RGB,256,256,256);
    //Positionen berechnen
    masse1X = ruhelage + l * sin( ZVaktuell[0] );
    masse1Y = ruhelage - l * cos( ZVaktuell[0] );
    masse2X = masse1X  + l * sin( ZVaktuell[1] );
    masse2Y = masse1Y  - l * cos( ZVaktuell[1] );
   
    // Pendel zeichnen
    stroke(10);
    strokeWeight(12);
    line( ruhelage, ruhelage, masse1X, masse1Y ); //Oberer Pendelstab
    line( masse1X, masse1Y, masse2X, masse2Y ); //Unterer Pendelstab
    strokeWeight(2);
    fill(0,200,0);
    ellipse( ruhelage, ruhelage, 15, 15 );
    // 1.Masse:
    fill(0,0,200);
    ellipse( masse1X, masse1Y, 40, 40 );//oberer Pendelkörper
    // 2.Masse:
    fill(200,0,0);
    ellipse( masse2X, masse2Y, 40, 40 ); //unterer Pendelkörper 
    
}
//////////////////////////////////////////////////////////
float[] ableitungZeit(float[] Y) {
    float[] ZustandsVektor = new float[n]; 
    // y = pos1, pos2, geschwindigkeit1, geschwindigkeit2
    ZustandsVektor[0]=Y[2];
    ZustandsVektor[1]=Y[3];
    // benötigte Werte :
    float sinDiff = sin(Y[0]-Y[1]);
    float cosDiff = cos(Y[0]-Y[1]);
    float cosProdukt = cosDiff * cosDiff;
    float s0 = sin(Y[0]);
    float s1 = sin(Y[1]);
    float alpha = - Y[3]*Y[3]*sinDiff + 2*G/l*s0 ;
    float beta = Y[2]*Y[2]*sinDiff + G/l*s1 ;
    ZustandsVektor[2]= 1 / (2-cosProdukt) * (alpha - cosDiff * beta); //Geschwindigkeit 1
    ZustandsVektor[3]= 1 / (2-cosProdukt) * (2*beta - cosDiff * alpha);//Geschwindigkeit 2 
    return ZustandsVektor;
}
/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
void mouseClicked() {//Neustart mit zufälligen Startwerten
  neuStarten();
}
////////////////////////////////////////////////////////////////////////////////
void keyPressed() {//Animation schneller/langsamer
  if (key == '+') {
    dt = dt*1.2;
  }
  if (key == '-') {
    dt = dt/1.2;
  }
}
///////////////////////////////////////////////////////////////////////////////
void neuStarten(){
  background(0);
  colorMode(HSB,256,256,256);
  farbe = color(random(256),256,256);
  w1=random(-0.5,0.5);   
  W1 = PI-w1;
  w2= random(-0.5,0.5);
  W2 = PI-w2;
  g1 =random(-0.5,0.5); 
  g2= random(-0.5,0.5); 
  ZVaktuell[0] = W1;
  ZVaktuell[1] = W2;         
  ZVaktuell[2] = g1;
  ZVaktuell[3] = g2;  
  EKontrolleA = masse*g1*g1*L*L +0.5*masse*g2*g2*L*L + masse*g1*g2*L*L*cos(w2-w1) - G*masse*L*(2*cos(w1)+cos(w2)-3);
  println("Start "+EKontrolleA);
 
}  
